SHMAT(2)

NAME
shmat, shmdt - attach or detach shared memory

SYNOPSIS
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
void *
shmat(int shmid, void *addr, int flag);
int
shmdt(void *addr);

DESCRIPTION
Shmat() attaches the shared memory segment identified by shmid to the calling process's address space. The address where the segment is attached is determined as follows:

•   If addr is 0, the segment is attached at an address selected by the kernel.

•   If addr is nonzero and SHM_RND is not specified in flag, the segment is attached the specified address.

•   If addr is specified and SHM_RND is specified, addr is rounded down to the nearest multiple of SHMLBA.

Shmdt() detaches the shared memory segment at the address specified by addr from the calling process's address space.

RETURN VALUES
Upon success, shmat() returns the address where the segment is attached; otherwise, -1 is returned and errno is set to indicate the error.

Upon success, shmdt() returns 0; otherwise, -1 is returned and errno is set to indicate the error.

ERRORS
Shmat() will fail if:

[EINVAL]
    No shared memory segment was found corresponding to shmid.

[EINVAL]
    addr was not an acceptable address.

Shmdt() will fail if:

[EINVAL]
    addr does not point to a shared memory segment.

SEE ALSO
shmget(2), shmctl(2)